Index: trunk/kernel/libk/rwlock.h
===================================================================
--- trunk/kernel/libk/rwlock.h	(revision 690)
+++ trunk/kernel/libk/rwlock.h	(revision 1)
@@ -1,6 +1,6 @@
 /*
- * rwlock.h - kernel local read/write lock definition.
+ * rwlock.h - kernel read/write lock definition.
  * 
- * Author   Alain Greiner    (2016,2017,2018)
+ * Author   Alain Greiner    (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,26 +25,24 @@
 #define _RWLOCK_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <busylock.h>
-#include <list.h>
+#include <almos_config.h>
+#include <hal_types.h>
 
-/******************************************************************************************n
- * This structure defines a kernel, local, read/write lock, supporting several simultaneous
- * read accesses, but only one write access to a given locally shared object in a cluster.
- * Both readers and writers take the associated busylock before accessing or updating
- * the rwlock state, and releases the busylock after rwlock state update.
- * - when a reader try to access the object, it increments the readers "count" when the 
- *   lock is not "taken" by a writer. It registers in the "rd_root" waiting queue, blocks,
- *   and deschedules when the lock is taken.
- * - when a writer try to take the rwlock, it check the "taken" field. If the lock is already
- *   taken, or if the number of readers is non zero, it registers in the "wr_root" waiting
- *   queue, blocks, and deschedules. It set "taken" otherwise.
- * - when a reader completes its access, it decrement the readers "count", unblock the
- *   the first waiting writer if there is no other readers, and unblock all waiting
- *   readers if there no write request.
- * - when a  writer completes its access, it reset the "taken" field, releases the first
- *   waiting writer if queue non empty, or releases all waiting readers if no writer.
+/*******************************************************************************************
+ * This structure defines a local rwlock, that supports several simultaneous read 
+ * accesses, but only one write access. It implements a ticket based allocation policy.
+ * Both readers and writers must take a ticket before doing anything else, and access
+ * are done in same order as requests (for both read an write ).
+ * - A reader take the lock to atomically increments the registered readers count.
+ *   Then it release the lock and access the protected structure. It atomically decrement
+ *   the readers count without taking the lock when access is completed.
+ * - A writer take the lock and keep it, but must wait completion of all current read 
+ *   accesses before starting its own access.
+ * As this local lock is only accessed by the local threads, if the lock is taken, 
+ * the new-comers use a busy waiting policy with a delay between retry.
  ******************************************************************************************/
+
+/****     Forward declarations    ****/
+
+struct thread_s;
 
 /*******************************************************************************************
@@ -54,9 +52,8 @@
 typedef struct rwlock_s
 {
-    busylock_t          lock;        /*! busylock protecting the rwlock state             */
-	volatile uint32_t   taken;       /*! lock taken by an exclusive writer if non zero    */
-    volatile uint32_t   count;       /*! current number of simultaneous readers threads   */
-    list_entry_t        rd_root;     /*! root of list of waiting readers                  */
-    list_entry_t        wr_root;     /*! root of list of waiting writers                  */
+	uint32_t            ticket;           /*! first free ticket index                     */
+    uint32_t            current;          /*! ticket index of current owner               */
+    uint32_t            count;            /*! number of simultaneous readers threads      */
+	struct thread_s   * owner;            /*! pointer on curent writer thread             */
 }
 rwlock_t;
@@ -64,12 +61,8 @@
 /*******************************************************************************************
  * This function initializes a local rwlock.
- * The <type> argument defines the lock usage and is only used for debug.
- * This type is actually stored in the associated busylock descriptor.
  *******************************************************************************************
- * @ lock       : pointer on rwlock.
- * @ type       : lock usage for debug.
+ * @ lock       : pointer on rwlock
  ******************************************************************************************/
-void rwlock_init( rwlock_t * lock,
-                  uint32_t   type );
+void rwlock_init( rwlock_t * lock );
 
 /*******************************************************************************************
@@ -78,5 +71,5 @@
  * @ lock       : pointer on rwlock
  ******************************************************************************************/
-void rwlock_rd_acquire( rwlock_t * lock );
+void rwlock_rd_lock( rwlock_t * lock );
 
 /*******************************************************************************************
@@ -85,5 +78,5 @@
  * @ lock       : pointer on rwlock
  ******************************************************************************************/
-void rwlock_wr_acquire( rwlock_t * lock );
+void rwlock_wr_lock( rwlock_t * lock );
 
 /*******************************************************************************************
@@ -92,5 +85,5 @@
  * @ lock       : pointer on rwlock
  ******************************************************************************************/
-void rwlock_rd_release( rwlock_t * lock );
+void rwlock_rd_unlock( rwlock_t * lock );
 
 /*******************************************************************************************
@@ -99,5 +92,5 @@
  * @ lock       : pointer on rwlock
  ******************************************************************************************/
-void rwlock_wr_release( rwlock_t * lock );
+void rwlock_wr_unlock( rwlock_t * lock );
 
 
Index: trunk/kernel/libk/spinlock.c
===================================================================
--- trunk/kernel/libk/spinlock.c	(revision 1)
+++ trunk/kernel/libk/spinlock.c	(revision 1)
@@ -0,0 +1,166 @@
+/*
+ * spinlock.c - kernel spinlock synchronization
+ * 
+ * Authors   Ghassan Almaless  (2008,2009,2010,2011,2012)
+ *           Alain Greiner     (2016}
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <hal_atomic.h>
+#include <hal_special.h>
+#include <hal_irqmask.h>
+#include <thread.h>
+#include <scheduler.h>
+#include <printk.h>
+#include <spinlock.h>
+
+//////////////////////////////////////////////
+inline void spinlock_init( spinlock_t * lock )
+{  
+	lock->taken = 0;
+	lock->owner = NULL;
+    list_entry_init( &lock->list );
+}
+
+///////////////////////////////////////////
+void spinlock_lock_busy( spinlock_t * lock, 
+                         uint32_t   * irq_state )
+{
+	uint32_t            mode;
+	volatile uint32_t   taken;
+	thread_t          * this     = CURRENT_THREAD;
+	bool_t              isAtomic = false;
+
+    // disable interrupts
+	hal_disable_irq( &mode );
+  
+    // loop until success
+	while( isAtomic == false )
+	{
+		taken = lock->taken;
+
+		if( taken == 0 )
+        {
+            // try to take the lock if not already taken
+		    isAtomic = hal_atomic_cas( &lock->taken , 0 , 1 );
+        }
+	}
+
+	this->local_locks++;
+    lock->owner = this;
+    list_add_first( &this->locks_root , &lock->list );
+
+    // enable interrupts if irq_state == NULL
+	if( irq_state ) *irq_state = mode;
+	else            hal_restore_irq( mode );
+}
+
+//////////////////////////////////////////////
+void spinlock_unlock_busy( spinlock_t * lock,
+                           bool_t       restore, 
+                           uint32_t     irq_state )
+{
+	thread_t * this = CURRENT_THREAD;;
+  
+    lock->owner = NULL;
+    lock->taken = 0;
+    this->local_locks--;
+    list_unlink( &lock->list );
+ 
+	if( restore ) hal_restore_irq( irq_state );
+}
+   
+///////////////////////////////////////
+void spinlock_lock( spinlock_t * lock )
+{
+	uint32_t          mode;
+	thread_t        * this     = CURRENT_THREAD;
+	bool_t            isAtomic = false;
+	volatile uint32_t taken;
+    
+    // disable interrupts
+	hal_disable_irq( &mode );
+  
+    // loop until success
+	while( isAtomic == false )
+	{
+        taken = lock->taken;
+
+        // deschedule without blocking when lock already taken
+		if( taken != 0 )
+        {
+            hal_restore_irq( mode );
+            if( thread_can_yield() ) sched_yield();
+            hal_disable_irq( &mode );
+            continue;
+        }
+
+        // try to atomically take the lock if not already taken
+	    isAtomic = hal_atomic_cas( &lock->taken , 0 , 1 );
+    }
+
+	this->local_locks++;
+    lock->owner = this;
+    list_add_first( &this->locks_root , &lock->list );
+
+    // enable interrupts
+    hal_restore_irq( mode );
+}
+
+//////////////////////////////////////////////
+uint32_t spinlock_trylock( spinlock_t * lock )
+{ 
+	uint32_t   mode;
+	bool_t     isAtomic = false;
+	thread_t * this     = CURRENT_THREAD;
+
+	hal_disable_irq( &mode );
+
+	if( lock->taken == 0)
+		isAtomic = hal_atomic_cas( &lock->taken , 0 , 1);
+  
+	if(isAtomic == false)
+	{
+		hal_restore_irq(mode);
+		return 1;
+	}
+    else
+    {
+	    this->local_locks++;
+	    lock->owner = this;
+        list_add_first( &this->locks_root , &lock->list );
+	    hal_restore_irq(mode);  
+	    return 0;
+    }
+}
+
+/////////////////////////////////////////
+void spinlock_unlock( spinlock_t * lock )
+{
+	thread_t * this = CURRENT_THREAD;
+  
+    lock->owner = NULL;
+    lock->taken = 0;
+    this->local_locks--;
+    list_unlink( &lock->list );
+}
+
+
Index: trunk/kernel/libk/spinlock.h
===================================================================
--- trunk/kernel/libk/spinlock.h	(revision 1)
+++ trunk/kernel/libk/spinlock.h	(revision 1)
@@ -0,0 +1,127 @@
+/*
+ * spinlock.h: kernel spinlock definition     
+ * 
+ * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
+ *          Alain Greiner    (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SPINLOCK_H_
+#define _SPINLOCK_H_
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <list.h>
+
+/*******************************************************************************************
+ * This structure defines a local spinlock, that sequencializes all read or write accesses
+ * in a given cluster. A new access can only start after completion of the previous access, 
+ * when the owner thread releases the lock. The lock has only two states: taken or free.
+ * The owner thread is registered in the spinlock_t structure, and the calling thread
+ * list of local spinlocks is updated. 
+ * 
+ * A spinlock can be accessed in three modes :
+ *
+ * - The spinlock_lock() function is BLOCKING and use a descheduling policy when the lock
+ *   is already taken. The lock must be released with the spinlock_unlock() function.
+ * - The spinlock_lock_noirq() function is BLOCKING, but uses a polling (busy-waiting)
+ *   policy if the lock is already taken. The IRQs can be disabled or not depending
+ *   on the irq_state argument. The lock must be released with the spinlock_unlock_noirq()
+ *   function.
+ * - The spinlock_trylock() function is NON-BLOCKING, and tries only once to take the lock.
+ *   It must be released with the spinlock_unlock() function.
+ ******************************************************************************************/
+
+/****     Forward declarations    ****/
+
+struct thread_s;
+
+/*******************************************************************************************
+ * This structure defines a local spinlock.
+ ******************************************************************************************/
+
+typedef struct spinlock_s
+{
+	uint32_t            taken;             /*! state : free if zero / taken if non zero  */
+	struct thread_s   * owner;             /*! pointer on curent owner thread            */
+    list_entry_t        list;              /*! list of all locks taken by owner          */
+}
+spinlock_t;
+
+/*******************************************************************************************
+ * This function initializes a local spinlock in free state.
+ *******************************************************************************************
+ * @ lock    : pointer on spinlock.
+ ******************************************************************************************/
+inline void spinlock_init( spinlock_t * lock );
+
+/*******************************************************************************************
+ * This blocking function uses a busy waiting strategy to lock a local spinlock.
+ * It polls the lock and returns only when the lock has been taken.
+ * If the irq_state argument is not NULL, all IRQs are disabled and will keep disabled
+ * until the lock is released. If irq_state is NULL, the IRQs are only disabled
+ * during the lock acquisition polling loop.
+ * It increments the calling thread local_locks count when the lock has been taken.
+ *******************************************************************************************
+ * @ lock       : pointer on spinlock
+ * @ irq_state  : buffer to save the SR state (in the calling thread stack)
+ ******************************************************************************************/
+void spinlock_lock_busy( spinlock_t * lock,
+                         uint32_t   * irq_state );
+
+/*******************************************************************************************
+ * This function releases a local busy_waiting spinlock.
+ * It restores the CPU SR state, if required by the restore argument.
+ *******************************************************************************************
+ * @ lock       : pointer on spinlock
+ * @ restore    : restore the CPU SR (from irq_state) if true
+ * @ irq_state  : value to be resrored in CPU SR 
+ ******************************************************************************************/
+void spinlock_unlock_busy( spinlock_t * lock,
+                           bool_t       restore,
+                           uint32_t     irq_state );
+
+/*******************************************************************************************
+ * This blocking function locks a local spinlock.
+ * If the lock is already taken, the calling thread deschedules and retries when
+ * it is rescheduled, until success.
+ * It increments the calling thread local_locks count when the lock has been taken.
+ *******************************************************************************************
+ * @ lock       : pointer on spinlock
+ ******************************************************************************************/
+void spinlock_lock( spinlock_t * lock );
+
+/*******************************************************************************************
+ * This non-blocking function tries once to lock a spinlock.
+ * It increments the calling thread locks count in case of success.
+ *******************************************************************************************
+ * @ lock       : pointer on spinlock
+ * @ returns 0 if success / returns non zero if lock already taken. 
+ ******************************************************************************************/
+uint32_t spinlock_trylock( spinlock_t * lock );
+
+/*******************************************************************************************
+ * This function releases a spinlock and do schedule if necessary.
+ *******************************************************************************************
+ * @ lock       : pointer on spinlock
+ ******************************************************************************************/
+void spinlock_unlock( spinlock_t * lock );
+
+
+#endif	/* _SPINLOCK_H_ */
Index: trunk/kernel/libk/sprintk.c
===================================================================
--- trunk/kernel/libk/sprintk.c	(revision 1)
+++ trunk/kernel/libk/sprintk.c	(revision 1)
@@ -0,0 +1,63 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2007
+*/
+
+/*
+ * $Log: sprintf.c,v $
+ * Revision 1.1.1.1  2002/02/28 12:58:56  disydent
+   Creation of Disydent CVS Tree
+ * Revision 1.2  2001/11/22 15:07:38  fred
+   Adding the iprintf function that does the formatting, and removes all
+   the old stuff hanging around.
+ * Revision 1.1.1.1  2001/11/19 16:55:47  pwet
+   Changing the CVS tree structure of disydent
+ * Revision 1.2  2001/11/14 12:12:26  fred
+   Modification for the call to printf and friends.
+   This should be reworked over sometime.
+ * Revision 1.1.1.1  2001/07/24 13:31:54  pwet
+   cvs tree of part of disydent
+ * Revision 1.1.1.1  2001/07/20 07:35:57  pwet
+   Embedded software cvs tree
+ * Revision 1.1  2000/07/24 08:16:05  denis
+   First archive of libc
+ * Revision 1.1  1998/09/16 16:11:22  pwet
+   passage a cvs
+ */
+
+
+#include <stdarg.h>
+#include <thread.h>
+#include <cluster.h>
+#include <libk.h>
+
+int sprintk (char *s, char *fmt, ...)
+{
+   va_list ap;
+   int count;
+
+   va_start (ap, fmt);
+
+   count = iprintk (s, current_cid, 1, fmt, ap);
+   *(s + count) = 0;
+
+   va_end (ap);
+
+   return count;
+}
+
Index: trunk/kernel/libk/string.c
===================================================================
--- trunk/kernel/libk/string.c	(revision 690)
+++ trunk/kernel/libk/string.c	(revision 1)
@@ -23,5 +23,5 @@
  */
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <ctype.h>
 #include <string.h>
@@ -31,4 +31,7 @@
 {
 	register const char *ptr = str;
+
+	if (str == NULL)
+		return 0;
 
 	while (*ptr) ptr++;
@@ -43,4 +46,7 @@
 	register const char *ptr = str;
 
+	if (str == NULL)
+		return 0;
+
 	while (*ptr && (maxlen-- > 0)) ptr++;
 
@@ -52,5 +58,7 @@
             const char * s2 )
 {
-
+	if((s1 == NULL) || (s2 == NULL))
+		return s1 - s2;
+  
 	while (*s1 && *s1 == *s2)
 	{
@@ -58,5 +66,5 @@
 		s2 ++;
 	}
-
+  
 	return (*s1 - *s2);
 }
@@ -67,7 +75,7 @@
              uint32_t     n )
 { 
-	if (n == 0)
-		return s1 - s2; // XXX ???
-
+	if((s1 == NULL) || (s2 == NULL) || (n == 0))
+		return s1 - s2;
+  
 	while (*s1 && (*s1 == *s2) && (n > 1))
 	{
@@ -76,5 +84,5 @@
 		n--;
 	}
-
+  
 	return (*s1 - *s2);
 }
@@ -87,9 +95,12 @@
 	char c2;
 
+	if((str1 == NULL) || (str2 == NULL))
+		return str1 - str2;
+  
 	do{
 		c1 = toupper(*++str1);
 		c2 = toupper(*++str2);
 	}while(c1 && c1 == c2);
-
+  
 	return (c1 - c2);
 }
@@ -102,7 +113,10 @@
 	char *dst_ptr = dest;
 
+	if(!dest || !src)
+		return dest;
+
 	while(*src_ptr)
 		*(dst_ptr++) = *(src_ptr++);
-
+  
 	*dst_ptr = 0;
 	return dest;
@@ -121,27 +135,6 @@
 	for (; i < n; i++)
 		dest[i] = '\0';
-
+  
 	return dest;
-}
-
-////////////////////////////////
-char * strstr( char       * s,
-               const char * find)
-{
-    char     sc;
-    char     c;
-    uint32_t len;
-
-    if ((c = *find++) != 0) {
-        len = strlen(find);
-        do {
-            do {
-                if ((sc = *s++) == 0)
-                    return NULL;
-            } while (sc != c);
-        } while (strncmp(s, find, len) != 0);
-        s--;
-    }
-    return s;
 }
 
@@ -150,4 +143,7 @@
                int          c )
 {
+	if(s == NULL)
+		return (char*)s;
+
 	while(*s && *s != (char) c)
 		s++;
@@ -155,5 +151,5 @@
 	if(*s == (char) c)
 		return (char*)s;
-
+  
 	return NULL;
 }
@@ -163,32 +159,12 @@
                 int          c )
 {
-	register char         ch;
-	register const char * l =0;
+  register char         ch;
+  register const char * l =0;
 
-	ch = c;
-	for (;;) {
-		if (*t == ch)
-			l=t;
-		if (!*t)
-			return (char*)l;
-		++t;
-	}
-	return (char*)l;
+  ch = c;
+  for (;;) {
+    if (*t == ch) l=t; if (!*t) return (char*)l; ++t;
+  }
+  return (char*)l;
 }
 
-/////////////////////////////////////
-inline uint8_t to_lower( uint8_t  c )
-{
-   if (c >= 'A' && c <= 'Z') return (c | 0x20);
-   else                      return c;
-}
-
-
-/////////////////////////////////////
-inline uint8_t to_upper( uint8_t  c )
-{
-   if (c >= 'a' && c <= 'z') return (c & ~(0x20));
-   else                      return c;
-}
-
-
Index: trunk/kernel/libk/string.h
===================================================================
--- trunk/kernel/libk/string.h	(revision 690)
+++ trunk/kernel/libk/string.h	(revision 1)
@@ -26,5 +26,5 @@
 #define _STRING_H_
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 
 
@@ -49,5 +49,5 @@
 /********************************************************************************************
  * This function compares lexicographically the strind s1 and s2.
- * Characters are considered unsigned.
+ * characters are considered unsigned.
  * I does not compare characters after the first NUL character.
  ********************************************************************************************
@@ -61,5 +61,5 @@
 /********************************************************************************************
  * This function compares lexicographically the strind s1 and s2.
- * I does not compare more than <n> characters and stops after the first NUL character.
+ * I does not compare than <n> characters and stops after the first NUL character.
  ********************************************************************************************
  * @ s1   : pointer on string.
@@ -83,39 +83,21 @@
 
 /********************************************************************************************
- * this function copies the <src> buffer to the <dst> buffer, including the terminating NUL.
+ * TODO
  ********************************************************************************************
- * @ dst   : pointer on destination buffer.
- * @ src   : pointer on source buffer.
  *******************************************************************************************/
-char * strcpy ( char * dst, 
+char * strcpy ( char * dest, 
                 char * src );
 
 /********************************************************************************************
- * This function copies <n> characters from the <sr> buffer to the <dst> buffer.
+ * TODO
  ********************************************************************************************
- * @ dst   : pointer on destination buffer.
- * @ src   : pointer on source buffer.
- * @ n     : number of characters to be copied.
  *******************************************************************************************/
-char * strncpy ( char    * dst,
+char * strncpy ( char    * dest,
                  char    * src,
                  uint32_t  n );
 
 /********************************************************************************************
- * This function locates the first occurence of the <find> string in the <s> string.
+ * TODO
  ********************************************************************************************
- * @ s     : string to be analysed.
- * @ find  : searched string
- * @ return pointer on the found string / return NULL if not found.
- *******************************************************************************************/
-char * strstr( char       * s,
-               const char * find);
-
-/********************************************************************************************
- * This function locates the first occurence of the <c> character in the <s> string.
- ********************************************************************************************
- * @ s     : string to be analysed.
- * @ c     : searched character value (casted to a char)
- * @ return pointer on the found character / return NULL if not found.
  *******************************************************************************************/
 char * strchr ( const char * s,
@@ -123,28 +105,9 @@
 
 /********************************************************************************************
- * This function locates the last occurence of the <c> character in the <s> string.
+ * TODO
  ********************************************************************************************
- * @ s     : string to be analysed.
- * @ c     : searched character value (casted to a char)
- * @ return pointer on the found character / return NULL if not found.
  *******************************************************************************************/
 char * strrchr ( const char * t,
                  int          c );
 
-/********************************************************************************************
- * This function returns a lower case ASCII code if input is in [A...Z] range.
- ********************************************************************************************
- * @ c     : character to be forced to lower case.
- * @ return lower case ASCII code.
- *******************************************************************************************/
-inline uint8_t to_lower( uint8_t  c );
-
-/********************************************************************************************
- * This function returns an upper case ASCII code if input is in [a...z] range.
- ********************************************************************************************
- * @ c     : character to be forced to upper case.
- * @ return upper case ASCII code.
- *******************************************************************************************/
-inline uint8_t to_upper( uint8_t  c );
-
 #endif	/* _STRING_H_ */
Index: trunk/kernel/libk/utils.h
===================================================================
--- trunk/kernel/libk/utils.h	(revision 1)
+++ trunk/kernel/libk/utils.h	(revision 1)
@@ -0,0 +1,93 @@
+/*
+ * libk/utils.h - useful functions for the kernel
+ * 
+ * Copyright (c) 2015 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _UTILS_H_
+#define _UTILS_H_
+
+#include <types.h>
+
+struct kernel_iter_s {
+        cid_t cid;
+};
+
+struct kernel_iter_s kernel_list;
+
+/* return the substration of two uint_t  while avoid	*
+ * the overflow case. Big is normally bigger than small.*/
+#if 0
+static uint_t uint_subwo(uint_t big, uint_t small)
+{
+	if(big >= small)
+		return (long)big - (long)small;
+	else	/* big has overflowed */
+		return (UINT32_MAX - small) + big;
+}
+#else
+#define uint_subwo(big, small)				\
+({							\
+	uint_t __ret;					\
+	if(big >= small)				\
+		__ret = big - small;			\
+	else	/* big has overflowed */		\
+		__ret = (UINT32_MAX - small) + big;	\
+	__ret;						\
+})
+#endif
+
+/* The number of kernel running on the platform (some clusters does not have
+ * a kernel, like the I/O cluster.
+ */
+#define  KERNEL_TOTAL_NR         current_cluster->clstr_wram_nr
+
+/* From Linux */
+#define container_of(ptr, type, member) ({                              \
+        const typeof( ((type *)0)->member ) *__mptr = (ptr);            \
+                (type *)( (char *)__mptr - offsetof(type,member) );})
+
+/* Assuming that all running kernels are contiguously in cluster 0,1,2 etc...,
+ * and empty cluster and I/O cluster are the two last. This is a very
+ * dangerous assumption, but for now we can't do otherwise. It should be
+ * marked as FIXME. This comment is also true for kernel_foreach_backward.
+ */
+#define kernel_foreach(iter, next)                              \
+        iter = &kernel_list;                                    \
+        next = 0;                                               \
+        for ( iter->cid = 0; iter->cid < KERNEL_TOTAL_NR;       \
+                        iter->cid++, next = iter->cid )
+
+/* cid_t is an unsigned int16_t and CID_NULL == (cid_t)-1 == 65535. When the
+ * loop is doing 0-1, it's equal to 65535, and so equal to CID_NULL, that's
+ * why this is the end loop condition.
+ * 
+ * You are not expected to understand this.
+ *
+ */
+#define kernel_foreach_backward_init(iter,next)                 \
+        iter = &kernel_list;                                    \
+        next = KERNEL_TOTAL_NR-1;
+
+#define kernel_foreach_backward(iter, next)                     \
+        kernel_foreach_backward_init(iter,next)                 \
+        for ( iter->cid = KERNEL_TOTAL_NR-1;                    \
+                        iter->cid != CID_NULL;                  \
+                        iter->cid--, next = iter->cid )
+
+#endif /* _UTILS_H_ */
